Package org.springframework.beans.factory.config

# Class PropertyPlaceholderConfigurer

java.lang.Object
org.springframework.core.io.support.PropertiesLoaderSupport
org.springframework.beans.factory.config.PropertyResourceConfigurer
org.springframework.beans.factory.config.PlaceholderConfigurerSupport
org.springframework.beans.factory.config.PropertyPlaceholderConfigurer

All Implemented Interfaces:
  `Aware`, `BeanFactoryAware`, `BeanNameAware`, `BeanFactoryPostProcessor`, `org.springframework.core.Ordered`, `org.springframework.core.PriorityOrdered`

Direct Known Subclasses:
  `PreferencesPlaceholderConfigurer`

@Deprecated public class PropertyPlaceholderConfigurer extends PlaceholderConfigurerSupport
Deprecated.
as of 5.2; use `org.springframework.context.support.PropertySourcesPlaceholderConfigurer` instead which is more flexible through taking advantage of the `Environment` and `PropertySource` mechanisms.
`PlaceholderConfigurerSupport` subclass that resolves ${...} placeholders against `local` `properties` and/or system properties and environment variables.

`PropertyPlaceholderConfigurer` is still appropriate for use when:

- the `spring-context` module is not available (i.e., one is using Spring's `BeanFactory` API as opposed to `ApplicationContext`).
- existing configuration makes use of the `"systemPropertiesMode"` and/or `"systemPropertiesModeName"` properties. Users are encouraged to move away from using these settings, and rather configure property source search order through the container's `Environment`; however, exact preservation of functionality may be maintained by continuing to use `PropertyPlaceholderConfigurer`.

Since:
  02.10.2003
Author:
  Juergen Hoeller, Chris Beams, Sam Brannen
See Also:
  - `setSystemPropertiesModeName(java.lang.String)`
  - `PlaceholderConfigurerSupport`
  - `PropertyOverrideConfigurer`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`SYSTEM_PROPERTIES_MODE_FALLBACK`
Deprecated.
Check system properties if not resolvable in the specified properties.
`static final int`
`SYSTEM_PROPERTIES_MODE_NEVER`
Deprecated.
Never check system properties.
`static final int`
`SYSTEM_PROPERTIES_MODE_OVERRIDE`
Deprecated.
Check system properties first, before trying the specified properties.

### Fields inherited from class org.springframework.beans.factory.config.PlaceholderConfigurerSupport

`DEFAULT_ESCAPE_CHARACTER, DEFAULT_PLACEHOLDER_PREFIX, DEFAULT_PLACEHOLDER_SUFFIX, DEFAULT_VALUE_SEPARATOR, escapeCharacter, ignoreUnresolvablePlaceholders, nullValue, placeholderPrefix, placeholderSuffix, trimValues, valueSeparator`

### Fields inherited from class org.springframework.core.io.support.PropertiesLoaderSupport

`localOverride, localProperties, logger`

### Fields inherited from interface org.springframework.core.Ordered

`HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

## Constructor Summary

Constructors
Constructor
Description
`PropertyPlaceholderConfigurer()`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`processProperties(ConfigurableListableBeanFactory beanFactoryToProcess, Properties props)`
Deprecated.
Visit each bean definition in the given bean factory and attempt to replace ${...} property placeholders with values from the given properties.
`protected String`
`resolvePlaceholder(String placeholder, Properties props)`
Deprecated.
Resolve the given placeholder using the given properties.
`protected String`
`resolvePlaceholder(String placeholder, Properties props, int systemPropertiesMode)`
Deprecated.
Resolve the given placeholder using the given properties, performing a system properties check according to the given mode.
`protected String`
`resolveSystemProperty(String key)`
Deprecated.
Resolve the given key as JVM system property, and optionally also as system environment variable if no matching system property has been found.
`void`
`setSearchSystemEnvironment(boolean searchSystemEnvironment)`
Deprecated.
Set whether to search for a matching system environment variable if no matching system property has been found.
`void`
`setSystemPropertiesMode(int systemPropertiesMode)`
Deprecated.
Set how to check system properties: as fallback, as override, or never.
`void`
`setSystemPropertiesModeName(String constantName)`
Deprecated.
Set the system property mode by the name of the corresponding constant, for example, "SYSTEM_PROPERTIES_MODE_OVERRIDE".

### Methods inherited from class org.springframework.beans.factory.config.PlaceholderConfigurerSupport

`doProcessProperties, setBeanFactory, setBeanName, setEscapeCharacter, setIgnoreUnresolvablePlaceholders, setNullValue, setPlaceholderPrefix, setPlaceholderSuffix, setTrimValues, setValueSeparator`

### Methods inherited from class org.springframework.beans.factory.config.PropertyResourceConfigurer

`convertProperties, convertProperty, convertPropertyValue, getOrder, postProcessBeanFactory, setOrder`

### Methods inherited from class org.springframework.core.io.support.PropertiesLoaderSupport

`loadProperties, mergeProperties, setFileEncoding, setIgnoreResourceNotFound, setLocalOverride, setLocation, setLocations, setProperties, setPropertiesArray, setPropertiesPersister`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### SYSTEM_PROPERTIES_MODE_NEVER

public static final int SYSTEM_PROPERTIES_MODE_NEVER
Deprecated.
Never check system properties.

See Also:
  - Constant Field Values

### SYSTEM_PROPERTIES_MODE_FALLBACK

public static final int SYSTEM_PROPERTIES_MODE_FALLBACK
Deprecated.
Check system properties if not resolvable in the specified properties. This is the default.

See Also:
  - Constant Field Values

### SYSTEM_PROPERTIES_MODE_OVERRIDE

public static final int SYSTEM_PROPERTIES_MODE_OVERRIDE
Deprecated.
Check system properties first, before trying the specified properties. This allows system properties to override any other property source.

See Also:
  - Constant Field Values

## Constructor Details

### PropertyPlaceholderConfigurer

public PropertyPlaceholderConfigurer()
Deprecated.

## Method Details

### setSystemPropertiesModeName

public void setSystemPropertiesModeName(String constantName) throws IllegalArgumentException
Deprecated.
Set the system property mode by the name of the corresponding constant, for example, "SYSTEM_PROPERTIES_MODE_OVERRIDE".

Parameters:
  `constantName` - name of the constant
Throws:
  `IllegalArgumentException`
See Also:
  - `setSystemPropertiesMode(int)`

### setSystemPropertiesMode

public void setSystemPropertiesMode(int systemPropertiesMode)
Deprecated.
Set how to check system properties: as fallback, as override, or never. For example, will resolve ${user.dir} to the "user.dir" system property.

The default is "fallback": If not being able to resolve a placeholder with the specified properties, a system property will be tried. "override" will check for a system property first, before trying the specified properties. "never" will not check system properties at all.

See Also:
  - `SYSTEM_PROPERTIES_MODE_NEVER`
  - `SYSTEM_PROPERTIES_MODE_FALLBACK`
  - `SYSTEM_PROPERTIES_MODE_OVERRIDE`
  - `setSystemPropertiesModeName(java.lang.String)`

### setSearchSystemEnvironment

public void setSearchSystemEnvironment(boolean searchSystemEnvironment)
Deprecated.
Set whether to search for a matching system environment variable if no matching system property has been found. Only applied when "systemPropertyMode" is active (i.e. "fallback" or "override"), right after checking JVM system properties.

Default is "true". Switch this setting off to never resolve placeholders against system environment variables. Note that it is generally recommended to pass external values in as JVM system properties: This can easily be achieved in a startup script, even for existing environment variables.

See Also:
  - `setSystemPropertiesMode(int)`
  - `System.getProperty(String)`
  - `System.getenv(String)`

### resolvePlaceholder

@Nullable protected String resolvePlaceholder(String placeholder, Properties props, int systemPropertiesMode)
Deprecated.
Resolve the given placeholder using the given properties, performing a system properties check according to the given mode.

The default implementation delegates to `resolvePlaceholder (placeholder, props)` before/after the system properties check.

Subclasses can override this for custom resolution strategies, including customized points for the system properties check.

Parameters:
  `placeholder` - the placeholder to resolve
  `props` - the merged properties of this configurer
  `systemPropertiesMode` - the system properties mode, according to the constants in this class
Returns:
  the resolved value, of null if none
See Also:
  - `setSystemPropertiesMode(int)`
  - `System.getProperty(java.lang.String)`
  - `resolvePlaceholder(String, java.util.Properties)`

### resolvePlaceholder

@Nullable protected String resolvePlaceholder(String placeholder, Properties props)
Deprecated.
Resolve the given placeholder using the given properties. The default implementation simply checks for a corresponding property key.

Subclasses can override this for customized placeholder-to-key mappings or custom resolution strategies, possibly just using the given properties as fallback.

Note that system properties will still be checked before respectively after this method is invoked, according to the system properties mode.

Parameters:
  `placeholder` - the placeholder to resolve
  `props` - the merged properties of this configurer
Returns:
  the resolved value, of `null` if none
See Also:
  - `setSystemPropertiesMode(int)`

### resolveSystemProperty

@Nullable protected String resolveSystemProperty(String key)
Deprecated.
Resolve the given key as JVM system property, and optionally also as system environment variable if no matching system property has been found.

Parameters:
  `key` - the placeholder to resolve as system property key
Returns:
  the system property value, or `null` if not found
See Also:
  - `setSearchSystemEnvironment(boolean)`
  - `System.getProperty(String)`
  - `System.getenv(String)`

### processProperties

protected void processProperties(ConfigurableListableBeanFactory beanFactoryToProcess, Properties props) throws BeansException
Deprecated.
Visit each bean definition in the given bean factory and attempt to replace ${...} property placeholders with values from the given properties.

Specified by:
  `processProperties` in class `PropertyResourceConfigurer`
Parameters:
  `beanFactoryToProcess` - the BeanFactory used by the application context
  `props` - the Properties to apply
Throws:
  `BeansException` - in case of errors